matrix.

mget /type= corr /file='C:\smoke.spv' .

call eigen (cr,eigvect,eigval).
compute loadings = eigvect * sqrt(mdiag(eigval)).
compute nvars = ncol(cr).
compute fm = make(nrow(cr),2,-9999).
compute fm(1,2) = (mssq(cr)-nvars)/(nvars*(nvars-1)).
compute fm4 = fm.
compute fm4(1,2) = (msum(cr &**4)-nvars)/(nvars*(nvars-1)).
loop #m = 1 to nvars - 1.
compute biga = loadings(:,1:#m).
compute partcov = cr - (biga * t(biga)).
compute d = mdiag( 1 / (sqrt(diag(partcov))) ).
compute pr = d * partcov * d.
compute fm(#m+1,2) = (mssq(pr)-nvars)/(nvars*(nvars-1)).
compute fm4(#m+1,2) = (msum(pr &**4)-nvars)/(nvars*(nvars-1)).
end loop.

* identifying the smallest fm value & its location (= # factors).
compute minfm = fm(1,2).
compute nfacts = 0.
compute minfm4 = fm4(1,2).
compute nfacts4 = 0.
loop #s = 1 to nrow(fm).
compute fm(#s,1) = #s -1.
compute fm4(#s,1) = #s - 1.
do if ( fm(#s,2) < minfm ).
compute minfm = fm(#s,2).
compute nfacts = #s - 1.
end if.
do if ( fm4(#s,2) < minfm4 ).
compute minfm4 = fm4(#s,2).
compute nfacts4 = #s - 1.
end if.
end loop.

print /title="Velicer's Minimum Average Partial (MAP) Test:".
print eigval  /title="Eigenvalues" /format "f12.4".
print { fm, fm4(:,2) } /title="Average Partial Correlations"
 /clabels= " " "squared"   "power4" /format "f14.4".
print minfm /title="The smallest average squared partial correlation is"/format "f12.4".
print nfacts  /title="The Number of Components According to the Original (1976) MAP Test is".

end matrix.